// -------------------------------------------------------------------------------- 
//!  @file  XInputCom.cpp                                                           
//!  XInput ̓͂ COM |[goRőMsAṽ\[Xt@C               
//                                                                                  
//   Copyright (C) 2021 lsluk, All rights reserved.                                 
//   http://vdmgr.g2.xrea.com/index.html                                            
// -------------------------------------------------------------------------------- 
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>
#include <process.h>
#include <setupapi.h>
#include <XInput.h>
#include "Resource.h"

#pragma comment (lib, "setupapi.lib")
#pragma comment (lib, "xinput.lib")

	// [U[bZ[W
	enum {
		UM_SENDSTART				=	WM_APP,						//!< pbhԑMJn
		UM_SENDSTOP,												//!< pbhԑM~
		UM_UPDATECONNECT,											//!< pbhڑԍXV
	} ;


static HINSTANCE					m_hInst ;						//!< CX^X̃nh
static HWND							m_hDlg ;						//!< _CAÕnh
static HWND							m_hComPortWnd ;					//!< R|[gEBhẼnh
static HWND							m_hBaudrateWnd ;				//!< {[[gEBhẼnh
static HWND							m_hConnectWnd ;					//!< ڑ{^EBhẼnh
static HWND							m_hDisconnectWnd ;				//!< ؒf{^EBhẼnh
static HANDLE						m_hThread ;						//!< Xbh̃nh
static DWORD						m_dwThread ;					//!< Xbh̎ʎq
static HANDLE						m_hComPort ;					//!< COM |[g̃nh


static const UINT32					m_nBaudrate[]={					//!< {[[g
										9600,
										14400,
										19200,
										38400,
										57600,
										115200,
										230400,
										460800,
										921600
									} ;


// -------------------------------------------------------------------------------- 
//!  Xbh                                                                   
//!                                                                                 
//!  @param [in] pParam  p[^                                                 
//!  @return             O                                                         
// -------------------------------------------------------------------------------- 
static unsigned __stdcall ThreadProc( void *pParam )
{
	MSG				msg ;
	XINPUT_STATE	xinputState[4], xinputStateOld[4], *pXInputState ;
	BOOL			bResult, bStart ;
	DWORD			dwResult, dwMilliseconds ;
	UINT8			nSendData[10], nStatus, nStatusOld ;
	INT				nIndex, nUpdate ;

	// bZ[WL[쐬
	PeekMessage(&msg, NULL, WM_USER, WM_USER, PM_NOREMOVE) ;

	// 
	bStart         = FALSE ;
	nStatusOld     = 0 ;
	dwMilliseconds = 100 ;

	while( 1 ) {
		// bZ[W擾
		if( PeekMessage(&msg, NULL, 0, 0, PM_REMOVE) != FALSE ) {

			switch( msg.message ) {
				case WM_QUIT:
					return 0 ;

				case UM_SENDSTART:
				{
					memset(&xinputState[0], 0, sizeof( xinputState )) ;
					bStart         = TRUE ;
					dwMilliseconds = 5 ;
					break ;
				}

				case UM_SENDSTOP:
				{
					bStart         = FALSE ;
					dwMilliseconds = 100 ;
					break ;
				}
			}
		}

		Sleep( dwMilliseconds ) ;

		// ԍXV
		memcpy(&xinputStateOld[0], &xinputState[0], sizeof( xinputState )) ;
		nUpdate = -1 ;
		nStatus = 0 ;

		pXInputState = &xinputState[0] ;
		for(nIndex=0; nIndex<4; nIndex++,pXInputState++) {
			dwResult = XInputGetState(nIndex, pXInputState) ;
			if( dwResult == ERROR_SUCCESS ) {
				nStatus |= (1 << nIndex) ;
			} else {
				memset(pXInputState, 0, sizeof( XINPUT_STATE )) ;
			}

			if( (bStart==FALSE) || (nUpdate!=-1) ) {
				continue ;
			}

			if( pXInputState->dwPacketNumber ==  xinputStateOld[nIndex].dwPacketNumber ) {
				continue ;
			}

			if( !memcmp(&pXInputState->Gamepad, &xinputStateOld[nIndex].Gamepad, sizeof( XINPUT_GAMEPAD )) ) {
				continue ;
			}

			// pbhԑM
			nSendData[0] = 0xf8 ;
			nSendData[1] = (((pXInputState->Gamepad.wButtons & XINPUT_GAMEPAD_A)              != 0) << 0) |
			               (((pXInputState->Gamepad.wButtons & XINPUT_GAMEPAD_B)              != 0) << 1) |
			               (((pXInputState->Gamepad.wButtons & XINPUT_GAMEPAD_X)              != 0) << 2) |
			               (((pXInputState->Gamepad.wButtons & XINPUT_GAMEPAD_Y)              != 0) << 3) |
			               (((pXInputState->Gamepad.wButtons & XINPUT_GAMEPAD_LEFT_THUMB)     != 0) << 4) |
			               (((pXInputState->Gamepad.wButtons & XINPUT_GAMEPAD_RIGHT_THUMB)    != 0) << 5) |
			               (( pXInputState->Gamepad.bLeftTrigger  >= 0x80)                          << 6) |
			               (( pXInputState->Gamepad.bRightTrigger >= 0x80)                          << 7) ;
			nSendData[2] = (((pXInputState->Gamepad.wButtons & XINPUT_GAMEPAD_LEFT_SHOULDER)  != 0) << 0) |
			               (((pXInputState->Gamepad.wButtons & XINPUT_GAMEPAD_RIGHT_SHOULDER) != 0) << 1) |
			               (((pXInputState->Gamepad.wButtons & XINPUT_GAMEPAD_BACK)           != 0) << 2) |
			               (((pXInputState->Gamepad.wButtons & XINPUT_GAMEPAD_START)          != 0) << 3) |
			               (((pXInputState->Gamepad.wButtons & XINPUT_GAMEPAD_DPAD_LEFT)      != 0) << 4) |
			               (((pXInputState->Gamepad.wButtons & XINPUT_GAMEPAD_DPAD_RIGHT)     != 0) << 5) |
			               (((pXInputState->Gamepad.wButtons & XINPUT_GAMEPAD_DPAD_UP)        != 0) << 6) |
			               (((pXInputState->Gamepad.wButtons & XINPUT_GAMEPAD_DPAD_DOWN)      != 0) << 7) ;
			nSendData[3] = pXInputState->Gamepad.sThumbLX >> 8 ;
			nSendData[4] = pXInputState->Gamepad.sThumbLY >> 8 ;
			nSendData[5] = pXInputState->Gamepad.sThumbRX >> 8 ;
			nSendData[6] = pXInputState->Gamepad.sThumbRY >> 8 ;
			nSendData[7] = pXInputState->Gamepad.bLeftTrigger ;
			nSendData[8] = pXInputState->Gamepad.bRightTrigger ;
			nSendData[9] = 0xf9 ;
			bResult      = WriteFile(m_hComPort, &nSendData[0], sizeof( nSendData ), &dwResult, NULL) ;
			if( (bResult==FALSE) || (dwResult!=4) ) {
				continue ;
			}

			nUpdate = nIndex ;
		}

		// pbhڑԍXV
		if( nStatusOld != nStatus ) {
			nStatusOld  = nStatus ;
			PostMessage(m_hDlg, UM_UPDATECONNECT, 0, nStatus) ;
		}
	}
}


// -------------------------------------------------------------------------------- 
//!  COM |[g                                                               
//!                                                                                 
//!  @param [in] hCtrlWnd  Rg[EBhẼnh                         
//!  @return               񋓐                                                   
// -------------------------------------------------------------------------------- 
static INT EnumComPort( HWND hCtrlWnd )
{
	SP_DEVINFO_DATA		spDevInfoData ;
	HDEVINFO			hDevInfo ;
	HKEY				hKey ;
	BOOL				bResult ;
	DWORD				dwMemberIndex, dwType, dwSize, dwRegDataType, dwDescSize ;
	WCHAR				szBuff[4096] ;
	INT					nCount ;
	LONG				nResult ;


	hDevInfo = SetupDiGetClassDevs(&GUID_DEVINTERFACE_COMPORT, 0, 0, DIGCF_PRESENT|DIGCF_DEVICEINTERFACE) ;
	if( hDevInfo == NULL ) {
		return 0 ;
	}

	spDevInfoData.cbSize = sizeof( SP_DEVINFO_DATA ) ;
	nCount               = 0 ;
	dwMemberIndex        = 0 ;

	while( 1 ) {
		bResult = SetupDiEnumDeviceInfo(hDevInfo, dwMemberIndex++, &spDevInfoData) ;
		if( bResult == FALSE ) {
			break ;
		}

		hKey = SetupDiOpenDevRegKey(hDevInfo, &spDevInfoData, DICS_FLAG_GLOBAL, 0, DIREG_DEV, KEY_QUERY_VALUE) ;
		if( hKey == INVALID_HANDLE_VALUE ) {
			break ;
		}

		// |[g擾
		dwSize  = sizeof( szBuff ) - 1 ;
		nResult = RegQueryValueEx(hKey, L"PortName", NULL, &dwType, (BYTE *)&szBuff[0], &dwSize) ;
		if( nResult != ERROR_SUCCESS ) {
			continue ;
		}
		szBuff[dwSize/2-1] = L':' ;

		// 擾
		bResult = SetupDiGetDeviceRegistryProperty(hDevInfo, &spDevInfoData, SPDRP_DEVICEDESC, &dwRegDataType, (BYTE *)&szBuff[dwSize/2], sizeof( szBuff )-dwSize, &dwDescSize) ;
		if( bResult == FALSE ) {
			continue ;
		}

		SendMessage(hCtrlWnd, CB_ADDSTRING, 0, (LPARAM )&szBuff[0]) ;

		nCount++ ;
	}

	SetupDiDestroyDeviceInfoList( hDevInfo ) ;

	if( nCount ) {
		EnableWindow(hCtrlWnd, TRUE) ;
		SendMessage(hCtrlWnd, CB_SETCURSEL, 0, 0) ;
	}

	return nCount ;
}


// -------------------------------------------------------------------------------- 
//!  COM |[gJ                                                               
//!                                                                                 
//!  @retval S_OK    I                                                       
//!  @retval E_FAIL  ُI                                                       
// -------------------------------------------------------------------------------- 
static HRESULT OpenComPort( void )
{
	DCB		dcb ;
	HANDLE	hComPort ;
	BOOL	bResult ;
	WCHAR	szBuff[4+4096] ;
	PWSTR	pszEnd ;

	// I[vȂI
	if( m_hComPort != INVALID_HANDLE_VALUE ) {
		return E_FAIL ;
	}

	// COM |[g쐬
	szBuff[0] = L'\\' ;
	szBuff[1] = L'\\' ;
	szBuff[2] = L'.' ;
	szBuff[3] = L'\\' ;

	SendMessage(m_hComPortWnd, CB_GETLBTEXT, SendMessage(m_hComPortWnd, CB_GETCURSEL, 0, 0), (LPARAM )&szBuff[4]) ;

	pszEnd  = wcschr(&szBuff[4], L':') ;
	*pszEnd = L'\0' ;

	// COM |[gJ
	hComPort = CreateFile(&szBuff[0], GENERIC_READ|GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 0, NULL) ;
	if( hComPort == INVALID_HANDLE_VALUE ) {
		LoadString(m_hInst, IDS_E_OPENCOMPORT, &szBuff[0], _countof( szBuff )) ;
		MessageBox(m_hDlg, &szBuff[0], NULL, MB_OK|MB_ICONERROR) ;
		return E_FAIL ;
	}

	GetCommState(hComPort, &dcb) ;

	dcb.BaudRate     = m_nBaudrate[SendMessage(m_hBaudrateWnd, CB_GETCURSEL, 0, 0)] ;
	dcb.ByteSize     = 8 ;
	dcb.Parity       = NOPARITY ;
	dcb.StopBits     = ONESTOPBIT ;
	dcb.fOutxCtsFlow = FALSE ;
	dcb.fOutxDsrFlow = FALSE ;
	dcb.fDtrControl  = DTR_CONTROL_DISABLE ;
	dcb.fRtsControl  = RTS_CONTROL_DISABLE ;

	bResult = SetCommState(hComPort, &dcb) ;
	if( bResult == FALSE ) {
		CloseHandle( hComPort ) ;

		LoadString(m_hInst, IDS_E_SETCOMPORT, &szBuff[0], _countof( szBuff )) ;
		MessageBox(m_hDlg, &szBuff[0], NULL, MB_OK|MB_ICONERROR) ;
		return E_FAIL ;
	}

	m_hComPort = hComPort ;

	return S_OK ;
}


// -------------------------------------------------------------------------------- 
//!  COM |[g                                                             
//!                                                                                 
//!  @retval S_OK    I                                                       
//!  @retval E_FAIL  ُI                                                       
// -------------------------------------------------------------------------------- 
static HRESULT CloseComPort( void )
{
	// I[vȂI
	if( m_hComPort == INVALID_HANDLE_VALUE ) {
		return E_FAIL ;
	}

	CloseHandle( m_hComPort ) ;

	m_hComPort = INVALID_HANDLE_VALUE ;

	return S_OK ;
}


// -------------------------------------------------------------------------------- 
//!  _CAÕbZ[W                                                   
//!                                                                                 
//!  @param [in]     hWnd    EBhẼnh                                   
//!  @param [in]     uMsg    bZ[W                                             
//!  @param [in,out] wParam  Pp[^                                         
//!  @param [in,out] lParam  Qp[^                                         
//!  @return                 bZ[W̖߂l                                     
// -------------------------------------------------------------------------------- 
static INT_PTR CALLBACK DialogProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch( uMsg ) {
		case WM_INITDIALOG:
		{
			WCHAR		szBuff[32] ;
			INT			nIndex ;
			unsigned	nThreadId ;

			// 
			m_hDlg           = hDlg ;
			m_hComPortWnd    = GetDlgItem(hDlg, IDC_COMPORT) ;
			m_hBaudrateWnd   = GetDlgItem(hDlg, IDC_BAUDRATE) ;
			m_hConnectWnd    = GetDlgItem(hDlg, IDC_CONNECT) ;
			m_hDisconnectWnd = GetDlgItem(hDlg, IDC_DISCONNECT) ;
			m_hComPort       = INVALID_HANDLE_VALUE ;

			// ACRݒ
			SendMessage(hDlg, WM_SETICON, ICON_SMALL, (LPARAM )LoadIcon(m_hInst, MAKEINTRESOURCE( IDI_XINPUTCOM ))) ;

			// Xbh쐬
			m_hThread = (HANDLE )_beginthreadex(NULL, 0, ThreadProc, NULL, 0, &nThreadId) ;
			if( m_hThread == NULL ) {
				break ;
			}
			m_dwThread = nThreadId ;

			// {[[gݒ
			for(nIndex=0; nIndex<_countof( m_nBaudrate ); nIndex++) {
				swprintf_s(&szBuff[0], _countof( szBuff ), L"%d", m_nBaudrate[nIndex]) ;
				SendMessage(m_hBaudrateWnd, CB_ADDSTRING, 0, (LPARAM )&szBuff[0]) ;

				if( m_nBaudrate[nIndex] == 115200 ) {
					SendMessage(m_hBaudrateWnd, CB_SETCURSEL, nIndex, 0) ;
				}
			}

			// COM |[g
			if( EnumComPort( m_hComPortWnd ) ) {
				EnableWindow(m_hBaudrateWnd, TRUE) ;
				EnableWindow(m_hConnectWnd,  TRUE) ;
			}

			return TRUE ;
		}

		case WM_COMMAND:
		{
			switch( LOWORD( wParam ) ) {
				case IDCANCEL:
				{
					// Xbh~
					PostThreadMessage(m_dwThread, WM_QUIT, 0, 0) ;

					if( WaitForSingleObject(m_hThread, 5000) != WAIT_OBJECT_0 ) {
						TerminateThread(m_hThread, (DWORD )-1) ;
					}
					CloseHandle( m_hThread ) ;

					EndDialog(hDlg, 0) ;
					break ;
				}

				case IDC_CONNECT:
				{
					HRESULT		hResult ;

					// COM |[gJ
					hResult = OpenComPort() ;
					if( FAILED( hResult ) ) {
						break ;
					}

					EnableWindow(m_hComPortWnd,    FALSE) ;
					EnableWindow(m_hBaudrateWnd,   FALSE) ;
					EnableWindow(m_hConnectWnd,    FALSE) ;
					EnableWindow(m_hDisconnectWnd, TRUE) ;

					// pbhԑMJn
					PostThreadMessage(m_dwThread, UM_SENDSTART, 0, 0) ;
					break ;
				}

				case IDC_DISCONNECT:
				{
					// COM |[g
					CloseComPort() ;

					// pbhԑM~
					PostThreadMessage(m_dwThread, UM_SENDSTOP, 0, 0) ;

					EnableWindow(m_hComPortWnd,    TRUE) ;
					EnableWindow(m_hBaudrateWnd,   TRUE) ;
					EnableWindow(m_hConnectWnd,    TRUE) ;
					EnableWindow(m_hDisconnectWnd, FALSE) ;
					break ;
				}

				default:
					break ;
			}
			break ;
		}

		case UM_UPDATECONNECT:
		{
			WCHAR	szBuff[5] ;
			INT		nIndex ;


			for(nIndex=0; nIndex<4; nIndex++) {
				if( ((UINT )lParam>>nIndex) & 1 ) {
					szBuff[nIndex] = L'' ;
				} else {
					szBuff[nIndex] = L'~' ;
				}
				szBuff[4] = L'\0' ;
			}

			SetDlgItemText(hDlg, IDC_STATUS, &szBuff[0]) ;
			break ;
		}

		default:
			break ;
	}

	return FALSE ;
}


// -------------------------------------------------------------------------------- 
//!  C                                                                     
//!                                                                                 
//!  @param [in] hInstance      ݂̃CX^X̃nh                        
//!  @param [in] hPrevInstance  ȑÕCX^X̃nh                        
//!  @param [in] pszCmdLine     R}hC                                      
//!  @param [in] nCmdShow       \                                            
//   @retval     0              I                                            
//   @retval     1              ُI                                            
// -------------------------------------------------------------------------------- 
INT APIENTRY wWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, PCWSTR pcszCmdLine, INT nCmdShow)
{
	m_hInst = hInstance ;

	return (INT )DialogBox(hInstance, MAKEINTRESOURCE( IDD_XINPUTCOM ), NULL, DialogProc) ;
}
